<template>
  <div class="container">
    <form-card :title="'Create User Account'">
      <div class="card-item">
        <label class="text-80 form-label">Balance</label>
        <div class="input-display">
          <form-input
            :updateValue="getInputValue"
            :type="'number'"
            :getErrors="getErrors"
          >
          </form-input>
          <p v-if="numberErrors" class="error-msg">{{ numberErrors }}</p>
        </div>
      </div>
      <div class="card-item">
        <label class="text-80 form-label">Currency</label>
        <custom-select
          :url="currencyUrl"
          :data="currencies"
          :title="'Currency'"
          :selectedItem="selectedItem"
          :nextPage="currenciesResponse.nextPage"
          :getMoreData="getCurrencies"
          :getSearchData="getCurrencies"
          :selectItem="selectItem"
          :searchInput="true"
          class="form-section"
        />
      </div>
    </form-card>
    <div class="btn-container">
      <custom-button :title="'Create Currency'" :submit="submitForm" />
    </div>
  </div>
</template>

<script>
import { mapGetters } from "vuex";
import { mapActions } from "vuex";
export default {
  mounted() {
    this.getCurrencies(this.currencyUrl, false);
    this.getUUID();
  },
  data() {
    return {
      currencyUrl: "/nova-api/currencies",
      account: {
        balance: null,
        currency: null,
        user: null,
        account_number: null,
      },
      selectedItem: [],
      uuid: null,
      numberErrors: "",
    };
  },
  computed: {
    ...mapGetters("moduleCurrency", {
      currencies: "getCurrencies",
      currenciesResponse: "getCurrenciesResponse",
    }),
  },
  methods: {
    ...mapActions("moduleCurrency", {
      fetchCurrencies: "fetchCurrencies",
    }),
    getCurrencies(url, loadMore, searchQuery) {
      this.fetchCurrencies({ url: url, loadMore: loadMore, searchQuery: searchQuery });
    },
    submitForm() {
      if (!this.validateForm()) {
        return false;
      }
      this.account.account_number = this.uuid;
      this.account.currency = this.selectedItem[0].id.value;
      this.account.user = Nova.config.userId;
      Nova.request()
        .post("/nova-api/accounts", this.account, {
          params: {
            editing: true,
            editMode: "create",
          },
        })
        .then((response) => {
          this.$router.push(response.data.redirect);
        });
    },
    selectItem(currency) {
      if (this.selectedItem.find((element) => element.title == currency.title)) {
        this.selectedItem.pop();
      } else {
        this.selectedItem.pop();
        this.selectedItem.push(currency);
      }
    },
    getUUID() {
      Nova.request()
        .get("/api/accounts/generateUUID")
        .then((response) => {
          this.uuid = response.data;
        });
    },
    getInputValue(value) {
      this.account.balance = value;
    },
    getErrors(value) {
      this.numberErrors = value;
    },
    validateForm() {
      return this.account.balance < 0 ||
        this.numberErrors.length > 0 ||
        this.selectedItem.length < 1
        ? false
        : true;
    },
  },
};
</script>
